//
// Cforall Version 1.0.0 Copyright (C) 2015 University of Waterloo
//
// The contents of this file are covered under the licence agreement in the
// file "LICENCE" distributed with Cforall.
//
// GenInit.h --
//
// Author           : Rodolfo G. Esteves
// Created On       : Mon May 18 07:44:20 2015
// Last Modified By : Rob Schluntz
// Last Modified On : Fri May 13 11:27:19 2016
// Update Count     : 3
//

#ifndef GEN_INIT_H
#define GEN_INIT_H

#include <string>
#include <list>

#include "SynTree/SynTree.h"
#include "SynTree/Declaration.h"
#include "SynTree/Mutator.h"

namespace InitTweak {
	/// Adds return value temporaries and wraps Initializers in ConstructorInit nodes
	void genInit( std::list< Declaration * > & translationUnit );

	/// creates an appropriate ConstructorInit node which contains a constructor, destructor, and C-initializer
	ConstructorInit * genCtorInit( ObjectDecl * objDecl );
} // namespace

#endif // INITTWEAK_GENINIT_H

// Local Variables: //
// tab-width: 4 //
// mode: c++ //
// compile-command: "make install" //
// End: //
